mod lowlevel;
mod nodes;

pub use nodes::Node;
pub use nodes::Nodes;

pub mod channel_tags {
    pub struct SendPacketTag {}
    pub struct ReceivePacketTag {}
    pub struct MinorTickTag {}
    pub struct MajorTickTag {}
}

#[derive(PartialEq, PartialOrd)]
pub enum SendOrder {
    Serialize,
    Sign,
    Encrypt,
    Send,
}
pub type SendPacketChannel = (channel_tags::SendPacketTag, crate::io::Packet, SendOrder);
#[derive(PartialEq, PartialOrd)]
pub enum ReceiveOrder {
    Decryption,
    Verify,
    Parse,
    Dispatch,
}
pub type ReceivePacketChannel = (channel_tags::ReceivePacketTag, crate::io::Packet, ReceiveOrder);
pub type MinorTickChannel = (channel_tags::MinorTickTag, ());
pub type MajorTickChannel = (channel_tags::MajorTickTag, ());

pub(crate) use lowlevel::LocalDiscovery;
pub(crate) use lowlevel::SendPacket;
